<script>
import { createEventDispatcher } from 'svelte'



const dispatch = createEventDispatcher()


export let items = []
export let active_item = {}

let new_index = -1


function addItem() {
    dispatch('new', true)
    new_index = items.length - 1
}

function startDragging(evt, index) {
    console.log("drag item", index)
    evt.dataTransfer.dropEffect = "move"
    evt.dataTransfer.effectAllowed = "move"
    evt.dataTransfer.setData("drop_on_button", index)
}

</script>

{#each items as item, index}
<div class={index == new_index ? "item new-item" : "item"}
    on:dragover|preventDefault 
    on:dragenter|preventDefault
    on:dragstart={(evt) => startDragging(evt, index)}
    draggable="true"
    style="color: {item === active_item ? 'orange' : 'black'}"
    on:click={() => dispatch('choose', index)}
>
<span>
{#if item === active_item}
    {active_item.name}
{:else}
    {item.name}
{/if}
</span>
</div>
{/each}


<button on:click={addItem}>
    <span class="material-symbols-outlined">add</span>
</button>

<style>

/* .center-items {
    display: flex;
    justify-content: center;
} */

button {
    font-variation-settings: 'wght' 200;
    margin-top: 20px;
    padding: 2px 0px;
    width: 30px;
    height: 30px;
    background: whitesmoke;
    transition: 0.2s;
    border-radius: 20px;
    border: none;
    user-select: none;
}

button:hover {
    color: orange;
}

button:focus {
  outline: 0;
}

.item {
    border-bottom: dashed black 1px;
    font-family: 'Arial';
    font-size: 12px;
    border-bottom: dashed black 1px;
    height: 35px;
}

.item:last-of-type {

    display: block;
    overflow: clip;
    border-bottom: solid black 1px;
}

.new-item {
    animation-duration: 0.3s;
    animation-name: new-item;
}

.item span {
    display: inline-block;
    margin: 10px 0px;
}

@keyframes new-item {
  from {
    opacity: 0%;
    height: 0px;
  }
  to {
    opacity: 100%;
    height: 35px;
  }
}

</style>